import { AccessControl, Permission } from 'accesscontrol';
import { DocumentQuery } from 'mongoose';
export declare class CrudAccessControl {
    private resource;
    private grants;
    ac: AccessControl;
    constructor(resource: string, grants: any);
    checkCreate(req: any): Promise<Check>;
    checkRead(req: any): Promise<Check>;
    checkUpdate(req: any): Promise<Check>;
    checkDelete(req: any): Promise<Check>;
    baseCheck(req: any, op: any, accessAnyCallback: (check: Check, access: any) => Check, accessOwnCallback: (check: Check, access: any) => Check): Promise<Check>;
    setOwner(req: any): (any) => any;
    filterAfterQuery(permission: Permission): (any) => any;
    restrictByUserOrOrganizationOwner(req: any): (query: any) => DocumentQuery<any, any>;
}
export declare class Check {
    isGranted: boolean;
    applyQueryRestriction: (query: DocumentQuery<any, any>) => DocumentQuery<any, any>;
    setBeforeUpdate: (any) => any;
    filterAfterQuery: (any) => any;
    constructor(isGranted?: boolean, applyQueryRestriction?: (query: DocumentQuery<any, any>) => DocumentQuery<any, any>, setBeforeUpdate?: (any) => any, filterAfterQuery?: (any) => any);
}
